#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#undef ulong
#define ulong	unsigned long

#undef uchar
#define uchar	unsigned char

int	err;

ulong long_ip(char *arg)
{
	char	ipbuf[32];   
	char	*p;
	uchar	a,b,c,d;
	ulong	ip;
	int	i;

	err = 0;

	strcpy(ipbuf,arg);
	p = strtok(ipbuf,".");
	i = atoi(p);
	if ((i < 0) || (i > 255))
		return(err = 1);
	a = i;
	p = strtok(NULL,".");
	i = atoi(p);
	if ((i < 0) || (i > 255))
		return(err = 1);
	b = i;
	p = strtok(NULL,".");
	i = atoi(p);
	if ((i < 0) || (i > 255))
		return(err = 1);
	c = i;
	p = strtok(NULL,".");
	i = atoi(p);
	if ((i < 0) || (i > 255))
		return(err = 1);
	d = i;

	ip = (a << 24) | (b << 16) | (c << 8) | d;
	return(ip);
}

char *ipstr(ulong ip)
{
	static	char sbuf[32];
	uchar	a,b,c,d;

	a = (ip & 0xff000000) >> 24;
	b = (ip & 0xff0000) >> 16;
	c = (ip & 0xff00) >> 8;
	d = ip & 0xff;

	sprintf(sbuf,"%i.%i.%i.%i",a,b,c,d);
	return(sbuf);
}

void usage(void)
{
	fprintf(stderr,"Usage: longip <ip_address|long_ip>\n");
	exit(1);
}

int main(int argc, char **argv)
{
	char	*p;
	ulong	lip;

	if (!argv[1])
		usage();

	if (strchr(argv[1],'.'))
	{
		lip = long_ip(argv[1]);
		if (err == 1)
		{
			fprintf(stderr,"error converting ip address\n");
			exit(1);
		}
		printf("%lu (0x%.8X)\n",lip,lip);
	}
	else
	{
		if (sscanf(argv[1],"%lu",&lip) != 1)
			usage();
		p = ipstr(lip);
		printf("%s\n",p);
	}
	return(0);
}
